<?php

const PKCS7_BLOCK_SIZE = 32; //PKCS7Padding 填充块长度
/**
 * 业务数据加密方法
 * 加密模式：AES128/CBC/PKCS7Padding
 * @param $aData 需要加密的数据数组
 * @param $sKey  合作商户的Key
 * @return string 加密后的数据（base64编码）
 */
function sEncryptData($aData, $sKey)
{
    if (empty($aData) || empty($sKey)) {
        return '';
    }

    $sData = json_encode($aData);
    $iPadLength = PKCS7_BLOCK_SIZE - (strlen($sData) % PKCS7_BLOCK_SIZE);
    $cPadChar = chr($iPadLength);
    $sData .= str_repeat($cPadChar, $iPadLength);

    $sIv = substr($sKey, 0, 16);
    $sEncrypt = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $sKey, $sData, MCRYPT_MODE_CBC, $sIv);
    $sEncrypt = base64_encode($sEncrypt);

    return $sEncrypt;
}

/**
 * 业务数据解密方法
 * @param $sEncrypt base64编码的加密数据字符串
 * @param $sKey  合作商户的Key
 * @return array
 */
function aDecryptData($sEncrypt, $sKey)
{
    $aData = array();

    if (empty($sEncrypt) || empty($sKey)) {
        return $aData;
    }

    $sIv = substr($sKey, 0, 16);
    $sEncrypt = base64_decode($sEncrypt);
    $sEncrypt = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $sKey, $sEncrypt, MCRYPT_MODE_CBC, $sIv);
    $iEncryptLength = strlen($sEncrypt);

    $iPadLength = ord($sEncrypt[$iEncryptLength - 1]);
    $sEncrypt = substr($sEncrypt, 0, $iEncryptLength - $iPadLength);

    $aData = json_decode($sEncrypt, true);
    return $aData;
}

$data = array(
    'id' => 10
);
echo sEncryptData($data, 'fv5gknn6r93l83olbisl1osicirpb9f');