<?php

const PKCS7_BLOCK_SIZE = 32; //PKCS7Padding 填充块长度
/**
 * 业务数据加密方法
 * 加密模式：AES128/CBC/PKCS7Padding
 * @param $aData 需要加密的数据数组
 * @param $sKey  合作商户的Key
 * @return string 加密后的数据（base64编码）
 */
function sEncryptData($aData, $sKey)
{
    if (empty($aData) || empty($sKey)) {
        return '';
    }

    $sIv = substr($sKey, 0, 16);
    $sData = json_encode($aData);
    $sEncrypt = openssl_encrypt($sData, 'AES-256-CBC', $sKey, 0 , $sIv); 

    return $sEncrypt;
}

/**
 * 业务数据解密方法
 * @param $sEncrypt base64编码的加密数据字符串
 * @param $sKey  合作商户的Key
 * @return array
 */
function aDecryptData($sEncrypt, $sKey)
{
    $aData = array();

    if (empty($sEncrypt) || empty($sKey)) {
        return $aData;
    }

    $sIv = substr($sKey, 0, 16);
    $sData = openssl_decrypt($sEncrypt, 'AES-256-CBC', $sKey, 0 , $sIv);
    $aData = json_decode($sData, true);

    return $aData;
}

$data = array(
    'id' => 10
);
echo sEncryptData($data, 'fv5gknn6r93l83olbisl1osicirpb9f');